/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.jcg.aspect;

import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.springframework.stereotype.Component;
import java.util.Arrays;

/**
 *
 * @author omozegieaziegbe
 */
@Aspect
@Component
public class LoggingAspect {

    // Pointcut for all methods in the 'com.jcg.service' package
    @Before("execution(* com.jcg.service..*(..))")
    public void logMethodExecution() {
        System.out.println("All methods in the 'com.jcg.service' package is being executed.");
    }
    
    @Before("execution(* com.jcg.service..*(..))")
    public void logMethodDetails(JoinPoint joinPoint) {
        System.out.println("Method name: " + joinPoint.getSignature().getName());       
        System.out.println("Class name: " + joinPoint.getTarget().getClass().getSimpleName());
        System.out.println("Executing method: " + joinPoint.getSignature().getDeclaringTypeName() + "." + joinPoint.getSignature().getName() + " in class: " + joinPoint.getTarget().getClass().getSimpleName());

    }
    
    // Pointcut for all methods in the 'com.jcg.service.sub' sub-package
    @Before("execution(* com.jcg.service.sub..*(..))")
    public void logSubPackageMethods(JoinPoint joinPoint) {
        String methodName = joinPoint.getSignature().getName();
        String className = joinPoint.getTarget().getClass().getSimpleName();
        System.out.println("Logging: Executing method inside 'com.jcg.service.sub'package: " + className + "." + methodName);
    }

}
